import java.io.*;
import java.util.*;
import javax.swing.*;

import java.awt.BorderLayout;
import java.awt.event.*;
class Employee implements Serializable {
	int id;
	String name;

	Employee(String name, int id) {
		this.name = name;
		this.id = id;
	}

	public int getId(){
		return id;
	}

	public String getName(){
		return name;
	}
}
class SwingFileDemo {
	FileOutputStream fout;
	ObjectOutputStream oos;
	FileInputStream fin;
	ObjectInputStream ois;
	public static void main(String args[])throws Exception {
		new SwingFileDemo();
	}

	SwingFileDemo(){
		initialize();
	}
	void initialize(){
		ArrayList<Employee> al=new ArrayList<Employee>();
		JFrame jf;
		JLabel jLId, jLName;
		JTextArea jLOp;
		JTextField jTId;
		JPasswordField jTName;
		JButton jBReg, jBDisp, jBLogin;
		JPanel jp;

		jf = new JFrame("Student Registration");

		jLId = new JLabel("Enter your id:");
		jLId.setBounds(40,10,100,20);
		jf.add(jLId);

		jTId = new JTextField();
		jTId.setBounds(150, 10, 100, 20);
		jf.add(jTId);

		jLName = new JLabel("Enter your Name:");
		jLName.setBounds(40,40,100,20);
		jf.add(jLName);

		jTName = new JPasswordField();
		jTName.setBounds(150, 40, 100, 20);
		jf.add(jTName);

		jLOp = new JTextArea();

		jp = new JPanel();
		jp.setBounds(60,140,200,200);
		jp.add(jLOp);
		jf.add(jp);

		//JScrollPane jsp = new JScrollPane(jp);
		//jf.add(jsp, BorderLayout.SOUTH);

		jBReg = new JButton("Register");
		jBReg.setBounds(60, 80, 90, 20);
		jBReg.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int i = Integer.parseInt(jTId.getText());
				String n = jTName.getText();	
				al.add(new Employee(n,i));
				jTName.setText("");
				jTId.setText("");
				// jLOp.setText("");
				try {
					File file = new File("LoginDetails.dat");
					if(file.exists()) {
						oos = new ObjectOutputStream(new FileOutputStream(file,true)) {
							@Override 
							protected void writeStreamHeader() throws IOException {
								reset();
							}
						};
					}
					else
						oos = new ObjectOutputStream(new FileOutputStream(file));
					oos.writeObject(al);
					System.out.println("added");
					al.clear();
					oos.close();
				}catch(Exception ae){
					ae.printStackTrace();
				}
			}
		});
		jf.add(jBReg);

		jBDisp = new JButton("Login");
		jBDisp.setBounds(160, 80, 80, 20);
		jBDisp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				boolean flag = false;
				try {
					fin = new FileInputStream("LoginDetails.dat");
					ois = new ObjectInputStream(fin);
					ArrayList<Employee> al1;
					int row = 0;
					String op = new String("");
					String name = jTName.getText();
					int id = Integer.parseInt(jTId.getText());

					while((al1=(ArrayList)ois.readObject())!=null){
						Employee e1 = al1.get(0);
						if(id==e1.getId()&&name.equals(e1.getName())){
							//System.out.println("1");
							flag = true;
							break;
						}
					}
					System.out.println(flag);
					if(flag==true){
						new SecondFrame(name);
						jf.setVisible(false);
					}
					else{
						System.out.println("2");
						JOptionPane.showMessageDialog(jf,"Login Failed");
					}
					jTId.setText("");
					jTName.setText("");
				} catch(Exception er){}
			}
		});
		jf.add(jBDisp);

		jBLogin = new JButton("Display");
		jBLogin.setBounds(110, 110, 80, 20);
		jBLogin.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try {
					fin = new FileInputStream("LoginDetails.dat");
					ois = new ObjectInputStream(fin);
					ArrayList<Employee> al1;
					int row = 0;
					String op = new String("");
					boolean flag = false;
					while((al1=(ArrayList)ois.readObject())!=null){
						Iterator<Employee> i=al1.iterator();
						while(i.hasNext()){
							Employee e1=i.next();
							op += e1.getId() + "\t" + e1.getName()+"\n";
							jLOp.setText(op);
						}
					}
				}catch(Exception er){}
			}
		});
		jf.add(jBLogin);

		jf.setSize(350,400);
		jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jf.setLayout(null);
		jf.setVisible(true);
	}
}